#ifndef _SYS_MMAN_H
#define _SYS_MMAN_H

#include <sys/types.h>

#ifndef MAP_ANON
#define MAP_ANON	MAP_ANONYMOUS	   /* idem */
#endif
#ifndef MAP_FILE
#define MAP_FILE	0x00	   /* The 'normal' way: mapped from file */
#endif

#define __P(x) x
typedef void *__ptr_t;
extern __ptr_t mmap __P((__ptr_t __addr, size_t __len,
		int __prot, int __flags, int __fd, off_t __off));
extern int munmap __P((__ptr_t __addr, size_t __len));
extern int mprotect __P ((__const __ptr_t __addr, size_t __len, int __prot));

extern int msync __P((__ptr_t __addr, size_t __len, int __flags));

extern int mlock __P((__const __ptr_t __addr, size_t __len));
extern int munlock __P((__const __ptr_t __addr, size_t __len));

extern int mlockall __P((int __flags));
extern int munlockall __P((void));

extern __ptr_t mremap __P((__ptr_t __addr, size_t __old_len,
			   size_t __new_len, int __may_move));
#undef __P


#define PROT_READ       0x1             /* page can be read */
#define PROT_WRITE      0x2             /* page can be written */
#define PROT_EXEC       0x4             /* page can be executed */
#define PROT_NONE       0x0             /* page can not be accessed */

#define MAP_SHARED   0x01            /* Share changes */
#define MAP_PRIVATE  0x02            /* Changes are private */
#define MAP_TYPE     0x0f            /* Mask for type of mapping */
#define MAP_FIXED    0x10            /* Interpret addr exactly */
#define MAP_ANONYMOUS 0

#define MAP_GROWSDOWN   0x0100          /* stack-like segment */
#define MAP_DENYWRITE   0x0800          /* ETXTBSY */
#define MAP_EXECUTABLE  0x1000          /* mark it as a executable */
#define MAP_LOCKED      0x2000          /* pages are locked */

#define MAP_FAILED (__ptr_t) -1

#endif /* _SYS_MMAN_H */
