#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <sys/mman.h>

extern char *_what_size_app_thinks_it_is;
extern char *_what_size_dpmi_thinks_we_are;
struct far_ptr {unsigned int offset; unsigned short segment;};
extern struct far_ptr mmap_pm_api;

#define DEBUG(x) fprintf x

__ptr_t mmap (__ptr_t __addr, size_t __len,
	      int __prot, int __flags, int __fd, off_t __off)
{
  int res;
  if (__fd != -1) {
    DEBUG ((stderr, "mmap called with fd %d != -1\n", __fd));
    errno = EBADF;
    return MAP_FAILED;
  }

  DEBUG ((stderr, "mmap: addr %08x, len %08x, flags %04x\n", __addr,
	  __len, __flags));

#if 0
  /* handle MAP_FIXED correctly someday */
  if (!(__flags & MAP_FIXED)) 
    __addr = _what_size_dpmi_thinks_we_are;
#endif
  if (!__addr)
    __addr = _what_size_dpmi_thinks_we_are;

  if ((__len & 0xfff) || ((unsigned int) __addr & 0xfff)) {
    DEBUG ((stderr, "invalid len or addr\n"));
    errno = EINVAL;
    return MAP_FAILED;
  }

  asm ("lcall %1\n\t"
       : "=a" (res)
       : "m" (mmap_pm_api), "a" (4), "c" (__len),
         "d" (__addr));

  if ((res == 0) || (res == 0x7777)) {
    DEBUG ((stderr, "vxd failed\n"));
    errno = ENOMEM;
    return;
  }

  /* if we allocated at end of heap, advance sbrk pointers */
  if (__addr == _what_size_dpmi_thinks_we_are) {
    _what_size_dpmi_thinks_we_are += __len;
    _what_size_app_thinks_it_is = _what_size_dpmi_thinks_we_are;
  }

  DEBUG ((stderr, "\tmmap succeeded: %08x\n", __addr));

  return __addr;
}

int munmap (__ptr_t __addr, size_t __len)
{
  int res;

  if ((__len & 0xfff) | ((unsigned int) __addr & 0xfff)) {
    DEBUG ((stderr, "munmap %08x, %08x bad val\n", __addr, __len));
    errno = EINVAL;
    return -1;
  }

  asm ("lcall %1\n\t"
       : "=a" (res)
       : "m" (mmap_pm_api), "a" (5), "c" (__len),
         "d" (__addr));
  if (res == 0) {
    DEBUG ((stderr, "munmap %08x, %08x vxd failed\n", __addr, __len));
    errno = ENOMEM;
    return -1;
  }

  DEBUG ((stderr, "munmap %08x, %08x OK\n", __addr, __len));
  return 0;
}
  

