#include <errno.h>

extern char *_what_size_app_thinks_it_is;
extern char *_what_size_dpmi_thinks_we_are;
extern char *__djgpp_selector_limit;
extern unsigned short __djgpp_ds_alias;
struct far_ptr {unsigned int offset; unsigned short segment;};
extern struct far_ptr mmap_pm_api;

static int get_vxd_pm_api(unsigned short id, 
			  char *vxdname, struct far_ptr *api)
{
  asm ("pushw  %%es\n\t"
       "movw   %%ds, %%ax\n\t"
       "movw   %%ax, %%es\n\t"
       "movw   $0x1684, %%ax\n\t"
       "int    $0x2f\n\t"
       "movw   %%es, %%ax\n\t"
       "popw   %%es"
       : "=a" (api->segment), "=D" (api->offset) : "b" (id), "D" (vxdname));
  api->offset &= 0xffff;
  return api->offset != 0;
}

/* first time through sbrk(), set selector limits appropriately */
static int selectors_need_fixing = 1;

void *__sbrk (int inc)
{
  char *newdpmi, *oldapp;
  int res, res2;
  static int times = 0;

  if (!mmap_pm_api.offset && !get_vxd_pm_api (0, "MMAP    ", &mmap_pm_api)) {
    /* should never happen -- MMAP should be there in order for the
       stub to be able to load us in the first place! */
    errno = ENOMEM;
    return (void *) -1;
  }

  if (selectors_need_fixing) {
    /* fix selectors: */
    newdpmi = (char *) (64 * 1024 * 1024 - 1);   /* 64MB -- see stub.asm */
    if (__dpmi_set_segment_limit (_my_cs(), newdpmi) == -1 ||
	__dpmi_set_segment_limit (_my_ds(), newdpmi) == -1 ||
	__dpmi_set_segment_limit (__djgpp_ds_alias, newdpmi) == -1) {
      errno = ENOMEM;
      return (char *) -1;
    }
    selectors_need_fixing = 0;
  }

  oldapp = _what_size_app_thinks_it_is;
  /* round up to nearest 64k */
  newdpmi = (char *) (((int) oldapp + inc + 0x0000ffff) & 0xffff0000);
  /* if no allocation required, just return */
  if (newdpmi <= _what_size_dpmi_thinks_we_are) {
    _what_size_app_thinks_it_is = oldapp + inc;
    return oldapp;
  }

  /* allocation required: */
  asm ("lcall %1\n\t"
       : "=a" (res)
       : "m" (mmap_pm_api), "a" (4), 
         "c" (newdpmi - _what_size_dpmi_thinks_we_are + 0x1000),
         "d" (_what_size_dpmi_thinks_we_are));
  if ((res == 0) || (res == 0x7777)) {
    /* failed */
    errno = ENOMEM;
    return (char *) -1;
  }

  _what_size_dpmi_thinks_we_are = newdpmi;
  _what_size_app_thinks_it_is = oldapp + inc;
  return oldapp;
}


int __brk (char *end)
{
  return __sbrk(end - _what_size_app_thinks_it_is) == (char *) -1 ?
    -1 : 0;
}
