
#include <dirent.h>
#include <malloc.h>

int scandir(const char *dirpath, struct dirent ***namelist,
	    int (*select)(), int (*compar)())
{
    int n = 0, alloc = 100;
    DIR *dir = NULL;
    struct dirent *dirent = NULL;
    struct dirent **arr = NULL;

    arr = malloc(alloc * sizeof(struct dirent *));
    if (!arr)
	goto error;

    dir = opendir(dirpath);
    if (!dir)
	goto error;

    while (dirent = readdir(dir)) {
	if (select && !(*select)(dirent))
	    continue;
	if (n >= alloc) {
	    alloc += 100;
	    arr = realloc(arr, alloc * sizeof(struct dirent *));
	    if (!arr)
		goto error;
	}
	arr[n] = malloc(sizeof(struct dirent));
	if (!arr[n])
	    goto error;
	*(arr[n]) = *dirent;
	n++;
    }

    qsort (arr, n, sizeof(struct dirent *), compar);
    closedir (dir);
    *namelist = arr;
    return n;

error:
    if (dir) closedir(dir);
    if (arr) {
	if (n)
	    do {
		free (arr[n]);
	    } while (n--);
	free (arr);
    }
    return -1;
}
