
#include <unistd.h>
#include <sys/uio.h>

int readv (int __fd, __const struct iovec * __vector, size_t __count)
{
  size_t bytes = 0, bytesthisbuf, bytesthistime;

  for ( ; __count; __count--, __vector++ ) {
    bytesthisbuf = 0;
    while ( bytesthisbuf < __vector->iov_len ) {
      bytesthistime = read(__fd, __vector->iov_base + bytesthisbuf, 
			   __vector->iov_len - bytesthisbuf);
      if (bytesthistime == 0 || bytesthistime == -1) 
	return bytes;
      bytesthisbuf += bytesthistime;
      bytes += bytesthistime;
    }
  }
  return bytes;
}

int writev (int __fd, __const struct iovec * __vector, size_t __count)
{
  size_t bytes = 0, bytesthisbuf, bytesthistime;

  for ( ; __count; __count--, __vector++ ) {
    bytesthisbuf = 0;
    while ( bytesthisbuf < __vector->iov_len ) {
      bytesthistime = write(__fd, __vector->iov_base + bytesthisbuf, 
			    __vector->iov_len - bytesthisbuf);
      if (bytesthistime == 0 || bytesthistime == -1) 
	return bytes;
      bytesthisbuf += bytesthistime;
      bytes += bytesthistime;
    }
  }
  return bytes;
}
